// *=================================================*
// * NapalmBomber  2003 by Sascha Willems           *
// * E-Mail : webmaster@delphigl.de                  *
// * Page   : http://www.delphigl.de                 *
// *=================================================*
// * This file is part of the "Bomberman"-Tutorial   *
// * series for http://www.delphigl.com              *
// *=================================================*
// * You may use this file in your own projects, but *
// * use it at your own risk ;-)                     *
// *=================================================*
// * NapalmEdit_1.pas                                *
// * Last changed : 03/09/2003                       *
// * Changes :                                       *
// *  - Initial Release                              *
// *=================================================*
unit NapalmEdit_1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,

  glBMP,
  OpenGL12, AppEvnts, global, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    ApplicationEvents1: TApplicationEvents;
    PopupMenu1: TPopupMenu;
    Startpunktplatzieren1: TMenuItem;
    Spieler11: TMenuItem;
    Spieler21: TMenuItem;
    Spieler31: TMenuItem;
    Spieler41: TMenuItem;
    FPSTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Spieler11Click(Sender: TObject);
    procedure Spieler21Click(Sender: TObject);
    procedure Spieler31Click(Sender: TObject);
    procedure Spieler41Click(Sender: TObject);
    procedure FPSTimerTimer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
   procedure DrawScene;
  end;

var
 CamAngle    : Integer;      // Kameraneigungswinkel
 MouseLeft   : Boolean;
 MouseRight  : Boolean;
 Frames      : Integer;      // Anzahl der gezeichneten Bilder (zur FPS-Ermittlung ntig)
 MousePos    : TPoint;       // Aktuelle Mausposition (wird fr die Selektion bentigt)
 Form1       : TForm1;
 MapRotation : Single;       // Rotation der Karte auf der Y-Achse
 RC          : HGLRC;        // Der OpenGL-Renderkontext
 DC          : HDC;          // Der GerteKontext dem der OpenGL-Renderkontext zugewiesen wird

implementation

uses NapalmEdit_2;

{$R *.dfm}

// =============================================================================
//  GetSelectBufferHit
// =============================================================================
//  Gibt die OpenGL-Kennung des vorher auf den Namestack gelegten getroffenen
//  Objekt zurck
// =============================================================================
function GetSelectBufferHit : Integer;
var
 SelectBuffer : array[0..512] of TGLUInt;
 Viewport     : TVector4i;
 Hits,i       : Integer;
 HitZValue    : TGLUInt;
 Hit          : TGLUInt;
begin
glGetIntegerv(GL_VIEWPORT, @viewport);
glSelectBuffer(512, @SelectBuffer);
glRenderMode(GL_SELECT);
glInitNames;
glPushName(0);
glMatrixMode(GL_PROJECTION);
glLoadIdentity;
gluPickMatrix(MousePos.x, viewport[3]-MousePos.y, 3.0, 3.0, Viewport);
gluPerspective(45.0, Form1.ClientWidth/Form1.ClientHeight, 0.1, 2048);
Form1.DrawScene;
Hits      := glRenderMode(GL_RENDER);
Hit       := High(TGLUInt);
HitZValue := High(TGLUInt);
for i := 0 to Hits-1 do
 if SelectBuffer[(i*4)+1] < HitZValue then
  begin
  Hit       := SelectBuffer[(i*4)+3];
  HitZValue := SelectBuffer[(i*4)+1];
  end;
Result := Hit;
end;

// =============================================================================
//  TForm1.FormCreate
// =============================================================================
//  Initialisierung wichtiger Variablen und OpenGLS
// =============================================================================
procedure TForm1.FormCreate(Sender: TObject);
const
 SpecialTexName : array[0..4] of String = ('player1.tga', 'player2.tga', 'player3.tga', 'player4.tga', 'bombable.tga');
var
 DummyPal : HPalette;
 i        : Integer;
begin
// Wichtige Variablen vorbelegen
CamAngle := 45;
Editor   := True;
Zoom     := 30;
// OpenGL-Renderingcontext erstellen
DC := GetDC(Handle);
RC := CreateRenderingContext(DC, [opDoubleBuffered], 32, 24, 8, 0, 0, 0, DummyPal);
// Rendercontext aktivieren und OpenGL initialisieren
ActivateRenderingContext(DC, RC);
glEnable(GL_TEXTURE_2D);
glEnable(GL_DEPTH_TEST);
glDepthFunc(GL_LESS);
glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
// Umgebungstexturen laden
TextureManager.AddTexturesInDir('textures', '*.tga');
for i := 0 to TextureManager.TextureName.Count-1 do
 Form2.TextureCombo.Items.Add(TextureManager.TextureName[i]);
Form2.StandardFieldCombo.Items := Form2.TextureCombo.Items;
ChDir(ExtractFilePath(Application.ExeName));
// Spezialtexturen laden
SetLength(SpecialTex, Length(SpecialTexName));
for i := Low(SpecialTexName) to High(SpecialTexName) do
 begin
 SpecialTex[i] := TglBMP.Create('textures\special\'+SpecialTexName[i]);
 SpecialTex[i].GenTexture(False, False);
 end;
Form2.TextureCombo.ItemIndex := 0;
Form2.FieldTypeCombo.ItemIndex := 0;
Form2.StandardFieldCombo.ItemIndex := 0;
// Karte initialisieren
Map.SetSize(32);
Map.FillGround(Form2.TextureCombo.Items[0],0);
Map.FillBorder(Form2.TextureCombo.Items[1],1);
Map.DefaultFieldTexture := Form2.StandardFieldCombo.Text;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
DeActivateRenderingContext;
DestroyRenderingContext(RC);
end;

// =============================================================================
//  TForm1.DrawScene
// =============================================================================
//  Zeichnen der eigentlichen Szene
// =============================================================================
procedure TForm1.DrawScene;
var
 RM : Cardinal;
begin
// Den aktuellen Rendermodus in der Variable RM ablegen
GLGetIntegerv(GL_RENDER_MODE, @RM);
// Farb- und Tiefenpuffer lschen
glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
// Wenn die Szene im Selectionsmodus gezeichnet wird, darf der Viewport nicht gendert werden,
// da die Selektion ansonsten nicht funktioniert
if RM <> GL_SELECT then
 begin
 glViewport(0, 0, ClientWidth, ClientHeight);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity;
 gluPerspective(45, ClientWidth/ClientHeight, 0.1, 1024);
 end;
glMatrixMode(GL_MODELVIEW);
glLoadIdentity;
glTranslatef(0,-0.5,-Zoom);
glRotatef(CamAngle, 1, 0 ,0);
glRotatef(MapRotation, 0, 1, 0);
// Spielfeld zentrieren
glTranslatef(-Length(Map.PlayGround)/2+ScrollX, 0, -Length(Map.PlayGround)/2+ScrollY);
SelField := nil;
Map.Draw;
SwapBuffers(DC);
end;

// =============================================================================
//  TForm1.ApplicationEvents1Idle
// =============================================================================
//  Auruf der Zeichenroutine sowie Eingebeverarbeitungen
// =============================================================================
procedure TForm1.ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
begin
DrawScene;
// Das unter dem Mauscursor liegende Feld mittels Selektion ermitteln
SBufferHit := GetSelectBufferHit;
inc(Frames);
Done := False;
// Bei linker Maustaste Textur und Feldtyp auf gewhltes Feld bertragen
if MouseLeft then
 if Assigned(SelField) then
  begin
  SelField^.Texture := Form2.TextureCombo.Items[Form2.TextureCombo.ItemIndex];
  SelField^.FType   := Form2.FieldTypeCombo.ItemIndex;
  end;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
if Zoom < 100 then
 inc(Zoom, 5);
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
if Zoom > 5 then
 dec(Zoom, 5);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
case Key of
 VK_ADD      : MapRotation := MapRotation+0.5;
 VK_SUBTRACT : MapRotation := MapRotation-0.5;
 VK_LEFT     : ScrollX := ScrollX+0.5;
 VK_RIGHT    : ScrollX := ScrollX-0.5;
 VK_UP       : ScrollY := ScrollY+0.5;
 VK_DOWN     : ScrollY := ScrollY-0.5;
 VK_NEXT     : begin
               inc(CamAngle, 15);
               if CamAngle > 90 then
                CamAngle := 0;
               end;
 VK_PRIOR    : begin
               dec(CamAngle, 15);
               if CamAngle < 0 then
                CamAngle := 90;
               end;
end;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
MousePos := Point(X,Y);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Application.Terminate;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
case Button of
 mbLeft  : MouseLeft  := True;
 mbRight : MouseRight := True;
end;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
case Button of
 mbLeft  : MouseLeft  := False;
 mbRight : MouseRight := False;
end;
end;

procedure TForm1.Spieler11Click(Sender: TObject);
begin
if Assigned(SelField) then
 SelField^.FSpecial := FSpecialPlayer1Start;
end;

procedure TForm1.Spieler21Click(Sender: TObject);
begin
if Assigned(SelField) then
 SelField^.FSpecial := FSpecialPlayer2Start;
end;

procedure TForm1.Spieler31Click(Sender: TObject);
begin
if Assigned(SelField) then
 SelField^.FSpecial := FSpecialPlayer3Start;
end;

procedure TForm1.Spieler41Click(Sender: TObject);
begin
if Assigned(SelField) then
 SelField^.FSpecial := FSpecialPlayer4Start;
end;

// =============================================================================
//  TForm1.FPSTimerTimer
// =============================================================================
//  Gibt einmal pro Sekunde die Anzahl der gezeichneten Bilder aus
//  (Frames per Second = FPS)
// =============================================================================
procedure TForm1.FPSTimerTimer(Sender: TObject);
begin
Form2.FPSLabel.Caption := 'FPS : '+IntToStr(Frames);
Frames := 0;
end;

end.
