// *=================================================*
// * NapalmBomber  2003 by Sascha Willems           *
// * E-Mail : webmaster@delphigl.de                  *
// * Page   : http://www.delphigl.de                 *
// *=================================================*
// * This file is part of the "Bomberman"-Tutorial   *
// * series for http://www.delphigl.com              *
// *=================================================*
// * You may use this file in your own projects, but *
// * use it at your own risk ;-)                     *
// *=================================================*
// * NapalmEdit_2.pas                                *
// * Last changed : 03/09/2003                       *
// * Changes :                                       *
// *  - Initial Release                              *
// *=================================================*
unit NapalmEdit_2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, global, ComCtrls, ToolWin, ImgList;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    TextureCombo: TComboBox;
    Label2: TLabel;
    FieldTypeCombo: TComboBox;
    FillBorderBtn: TButton;
    FillPlayGroundBtn: TButton;
    SetPlayGroundSizeBtn: TButton;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ImageList1: TImageList;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    StatusBar: TStatusBar;
    FPSLabel: TLabel;
    Label3: TLabel;
    StandardFieldCombo: TComboBox;
    procedure FillBorderBtnClick(Sender: TObject);
    procedure FillPlayGroundBtnClick(Sender: TObject);
    procedure SetPlayGroundSizeBtnClick(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure StandardFieldComboChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Zoom    : Integer;
  Form2   : TForm2;
  ScrollX : Single;
  ScrollY : Single;

implementation

{$R *.dfm}

// =============================================================================
//  Spielfeldrand mit gewhlter Textur und gewhltem Feldtyp fllen
// =============================================================================
procedure TForm2.FillBorderBtnClick(Sender: TObject);
begin
Map.FillBorder(TextureCombo.Text, FieldTypeCombo.ItemIndex);
end;

// =============================================================================
//  Spielfel mit gewhlter Textur und gewhltem Feldtyp fllen
// =============================================================================
procedure TForm2.FillPlayGroundBtnClick(Sender: TObject);
begin
Map.FillGround(TextureCombo.Text, FieldTypeCombo.ItemIndex);
end;

procedure TForm2.SetPlayGroundSizeBtnClick(Sender: TObject);
var
 i,j : Integer;
 S   : String;
begin
if MessageDlg('Achtung!Eine Vernderung der Spielfeldgre berschreibt ihre vorherige Karte!'+#13+'Mchten Sie fortfahren?', mtConfirmation,  [mbYes, mbNo] , 0) = mrNo then
 exit;
InputQuery('Spielfeldgre', 'Neue Spielfeldgre :', S);
if S = '' then
 exit;
for i := 1 to Length(S) do
 if not (S[i] in ['0'..'9']) then
  exit;
if StrToInt(S) < 8 then
 begin
 ShowMessage('Spielfeldgren < 8x8 Felder nicht erlaubt!');
 exit;
 end;
if StrToInt(S) > 64 then
 begin
 ShowMessage('Spielfeldgren > 64x64 Felder nicht erlaubt!');
 exit;
 end;
SetLength(Map.PlayGround, StrToInt(S));
for i := Low(Map.PlayGround) to High(Map.PlayGround) do
 begin
 SetLength(Map.PlayGround[i], StrToInt(S));
 for j := Low(Map.PlayGround[i]) to High(Map.PlayGround[i]) do
  with Map.PlayGround[i,j] do
   begin
   Texture  := Form2.TextureCombo.Items[0];
   FType    := 0;
   FSpecial := 0;
   end;
 end;
TextureCombo.ItemIndex   := 1;
FieldTypeCombo.ItemIndex := 1;
FillBorderBtnClick(self);
end;

procedure TForm2.ToolButton3Click(Sender: TObject);
begin
SaveDialog1.InitialDir := ExtractFilePath(Application.ExeName)+'\maps';
if not SaveDialog1.Execute then
 exit;
Map.SaveToFile(SaveDialog1.FileName);
StatusBar.SimpleText := ExtractFileName(SaveDialog1.FileName);end;

procedure TForm2.ToolButton2Click(Sender: TObject);
begin
OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName)+'\maps';
if not OpenDialog1.Execute then
 exit;
Map.LoadFromFile(OpenDialog1.FileName);
StatusBar.SimpleText := ExtractFileName(OpenDialog1.FileName);
ScrollX              := 0;
ScrollY              := 0;
Zoom                 := 10;
end;

procedure TForm2.StandardFieldComboChange(Sender: TObject);
begin
Map.DefaultFieldTexture := StandardFieldCombo.Text;
end;

end.
